import type { z } from "zod";
import { type RequestInputType } from "./errors";
export type Params<Params, Query, Body, Header> = {
    params: Params;
    query: Query;
    body: Body;
    headers: Header;
};
export declare function parseRequestInput<Schema extends z.ZodTypeAny>(schema: Schema, input: unknown, type: RequestInputType): z.infer<Schema>;
export declare function parseRequestInput(schema: undefined, input: unknown, type: RequestInputType): undefined;
export declare function responseValidationFactory(possibleResponses: [string, z.ZodTypeAny][], defaultResponse?: z.ZodTypeAny): (status: number, value: unknown) => any;
